using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Controles;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Mythos._3_Vistas.Controladoras;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using static Exferia_Aplicacion.General.Enumerados;
using System.Linq;
using System.Globalization;
using Exferia_Mythos._0_Modelos;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Formularios;
using System.Reflection;

namespace Exferia_Mythos._3_Vistas
{
    public partial class P_Inspeccion : Exferia_Formularios.P_Base_Mantenimientos
    {
        #region Variables Generales
        private P_Inspeccion_Controladora g_obj_Controladora;

        private bool g_bol_ConstructorPantalla_Terminado_Correctamente = true;
        public PRV_OpcionesDetalle g_mdl_PRV_OpcionesDetalle = null;

        internal List<INTERNO_Permisos_Modelo> g_lst_INTERNO_Permisos_Modelo = null;

        //Inspecciones relacionadas
        private INTERNO_ConfiguracionPantalla_Modelo g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS = null;

        //Variables paginador
        public Funciones_Paginador g_obj_Funciones_Paginador;
        private Timer g_timer_Paginar = new Timer();

        #endregion

        #region Objetos en Pantalla

        //Exferia_BarraProgreso
        internal Exferia_BarraProgreso Exferia_BarraProgreso_InspeccionesRelacionadas_BarraProgreso { get { return ex_pgb_P_Inspeccion_InspeccionesRelacionadas_BarraProgreso; } }

        //Exferia_DataGridView
        internal Exferia_DataGridView Exferia_DataGridView_InspeccionesRelacionadas { get { return ex_dgv_P_Inspeccion_InspeccionesRelacionadas; } }

        //Exferia_F3
        internal Exferia_F3 Exferia_F3_InstalacionCabecera { get { return ex_usc_F3_P_Inspeccion_InstalacionCabecera; } }
        internal Exferia_F3 Exferia_F3_OrganismoCertificador { get { return ex_usc_F3_P_Inspeccion_OrganismoCertificador; } }
        internal Exferia_F3 Exferia_F3_Resultado { get { return ex_usc_F3_P_Inspeccion_Resultado; } }

        //Exferia_F3_SoloSeleccion
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_Cliente { get { return ex_usc_F3_P_Inspeccion_Cliente; } }
        internal Exferia_F3_SoloSeleccion Exferia_F3_SoloSeleccion_InstalacionLinea { get { return ex_usc_F3_P_Inspeccion_InstalacionLinea; } }

        //Exferia_F3_SoloSeleccion_Simple
        internal Exferia_F3_SoloSeleccion_Simple Exferia_F3_SoloSeleccion_Simple_InspeccionRelacionada { get { return ex_usc_F3_P_Inspeccion_InspeccionRelacionada; } }

        //Exferia_FechaSeleccion
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaRecibiAviso { get { return ex_usc_P_Inspeccion_FechaRecibiAviso; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaRealizacionInspeccion { get { return ex_usc_P_Inspeccion_FechaRealizacionInspeccion; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaLlegadaInforme { get { return ex_usc_P_Inspeccion_FechaLlegadaInforme; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaPlazo { get { return ex_usc_P_Inspeccion_FechaPlazo; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaRecibipresupuesto { get { return ex_usc_P_Inspeccion_FechaRecibipresupuesto; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaComprobacionDefectos { get { return ex_usc_P_Inspeccion_FechaComprobacionDefectos; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaPresupuestoFirmado { get { return ex_usc_P_Inspeccion_FechaPresupuestoFirmado; } }
        internal Exferia_FechaSeleccion Exferia_FechaSeleccion_FechaPeticiónSegundaInspeccion { get { return ex_usc_P_Inspeccion_FechaPeticiónSegundaInspeccion; } }

        //Exferia_Label
        internal Exferia_Label Exferia_Label_Codigo { get { return ex_lbl_P_Inspeccion_Codigo; } }

        //Exferia_Paginador
        internal Exferia_Paginador Exferia_Paginador_Inspeccion { get { return ex_Paginador; } }

        //Exferia_TexBox
        internal Exferia_TextBox Exferia_TextBox_Codigo { get { return ex_txt_P_Inspeccion_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_Inspector_Nombre { get { return ex_txt_P_Inspeccion_Inspector_Nombre; } }
        internal Exferia_TextBox Exferia_TextBox_Inspector_Telefono { get { return ex_txt_P_Inspeccion_Inspector_Telefono; } }
        internal Exferia_TextBox Exferia_TextBox_Inspector_Email { get { return ex_txt_P_Inspeccion_Inspector_Email; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Codigo { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Codigo; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_CIF { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_CIF; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_RazonSocial { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_RazonSocial; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_NombreComercial { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_NombreComercial; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Telefono1 { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Telefono1; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Telefono2 { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Telefono2; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Fax { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Fax; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Email { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Email; } }
        internal Exferia_TextBox Exferia_TextBox_EmpresaInstaladora_Web { get { return ex_txt_P_Inspeccion_EmpresaInstaladora_Web; } }
        internal Exferia_TextBox Exferia_TextBox_Observaciones { get { return ex_txt_P_Inspeccion_Observaciones; } }

        #endregion

        #region Constructor
        public P_Inspeccion(INTERNO_ValoresGenerales_Modelo _mdl_INTERNO_ValoresGenerales_Modelo, DateTime _dtt_FechaTrabajo, PRV_OpcionesDetalle _mdl_PRV_OpcionesDetalle)
        {
            InitializeComponent();

            try
            {
                Repintar.Empezar(this);

                CheckForIllegalCrossThreadCalls = false;

                //Empresa seleccionada y fecha de trabajo ....................................................
                P_Base_ValoresGenerales = _mdl_INTERNO_ValoresGenerales_Modelo;
                P_Base_FechaTrabajo = _dtt_FechaTrabajo;

                //Instanciar Controladora
                g_obj_Controladora = new P_Inspeccion_Controladora(this);

                //Datos de Opciones detalle
                g_mdl_PRV_OpcionesDetalle = _mdl_PRV_OpcionesDetalle;

                //Buscar los Permisos
                g_lst_INTERNO_Permisos_Modelo = Datos_Generales.Permisos_Buscar(g_mdl_PRV_OpcionesDetalle.opcion);

                //Poner los botones que no se puedan poner bloqueados o solo de lectura
                ex_btn_P_Inspeccion_Grabar.Exferia_Button_Bloqueable = false;
                ex_btn_P_Inspeccion_Borrar.Exferia_Button_Bloqueable = false;

                //Mirar si hay que bloquear los controles, si solo puede ver los datos
                if ((P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, false)) == false)
                {
                    //Bloqueo los Controles
                    SoloLectura.Empezar(this, true);
                }

                //Tipo de campo Codigo, poner como numérico o texto ...............................
                if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO != null)
                {
                    //Si no existe es Text
                    if (Variables.G_LST_GEN_CONFIGURACION_CAMPOCODIGO.Where(m => m.nombreCampoCodigo.Equals(nameof(MYT_PartesTipos.codigo)) && m.opcion.Equals(g_mdl_PRV_OpcionesDetalle.opcion)).FirstOrDefault() != null)
                    {
                        ex_txt_P_Inspeccion_Codigo.Exferia_TextBox_Tipos = G_ENUM_TEXTBOX_TIPODATO.Digitos;
                        ex_txt_P_Inspeccion_Codigo.Exferia_TextBox_Tipo_Decimal_Enteros = ex_txt_P_Inspeccion_Codigo.Exferia_TextBox_MaxLength;

                        g_obj_Controladora.g_bol_CampoCodigo_Numerico = true;
                    }
                }

                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Inspecciones Relacionadas
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS = Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION()];
                    }
                }

                //Titulo de la Pantalla ............................................................................
                P_Base_TituloPantalla = _mdl_PRV_OpcionesDetalle.descripcion_TituloMantenimiento;

                //Label con Empresa Seleccionada
                if (P_Base_ValoresGenerales != null)
                {
                    try
                    {
                        P_Base_Mantenimientos_InformacionEmpresaSeleccionada = P_Base_ValoresGenerales.str_Empresa_Descripcion + " - " +
                                                                "(" + P_Base_FechaTrabajo.ToString("dd/MM/yyyy") + ")";
                    }
                    catch (Exception ex)
                    {
                        //No se muestra mensaje pero se guarda en el log
                        Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(P_Inspeccion));
                    }
                }
                //..................................................................................................................................

                //Bloquear pantalla hasta que termine la carga por defecto.....
                Enabled = false;
                //.............................................................

                //CLIENTE
                ex_usc_F3_P_Inspeccion_Cliente.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MAE_CLIENTE;
                ex_usc_F3_P_Inspeccion_Cliente.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_Cliente.Exferia_F3_SoloSeleccion_PRINCIPAL_BUSCARTITULO = false;

                //INSTALACIONCABECERA
                ex_usc_F3_P_Inspeccion_InstalacionCabecera.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_INSTALACIONESCABECERA;
                ex_usc_F3_P_Inspeccion_InstalacionCabecera.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_InstalacionCabecera.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;

                //INSTALACIONLINEA
                ex_usc_F3_P_Inspeccion_InstalacionLinea.Exferia_F3_SoloSeleccion_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_INSTALACIONESLINEAS;
                ex_usc_F3_P_Inspeccion_InstalacionLinea.Exferia_F3_SoloSeleccion_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_InstalacionLinea.Exferia_F3_SoloSeleccion_PRINCIPAL_BUSCARTITULO = false;

                //ORGANISMO CERTIFICADOR
                ex_usc_F3_P_Inspeccion_OrganismoCertificador.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_ORGANISMOSCERTIFICADORES;
                ex_usc_F3_P_Inspeccion_OrganismoCertificador.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_OrganismoCertificador.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;

                //INSPECCION RELACIONADA
                ex_usc_F3_P_Inspeccion_InspeccionRelacionada.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_INSPECCIONES;
                ex_usc_F3_P_Inspeccion_InspeccionRelacionada.Exferia_F3_SoloSeleccion_Simple_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_InspeccionRelacionada.Exferia_F3_SoloSeleccion_Simple_PRINCIPAL_BUSCARTITULO = false;

                //TIPO DE RESULTADO
                ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_PRINCIPAL_Opcion_BuscarDatos = Variables.G_STR_OPCION_MYT_INSPECCIONESTIPOSRESULTADOS;
                ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_PantallaContenedora = this;
                ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_PRINCIPAL_BUSCARTITULO = false;

                g_obj_Funciones_Paginador = new Funciones_Paginador();
            }
            catch (Control_Errores)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
            catch (Exception ex)
            {
                g_bol_ConstructorPantalla_Terminado_Correctamente = false;

                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(P_Inspeccion));
            }
            finally
            {
                //Bloquear pantalla hasta que termine la carga por defecto .....
                Enabled = true;
                //.............................................................
            }

        }
        #endregion

        #region Inicio de Pantalla
        private void P_Inspeccion_Load(object sender, EventArgs e)
        {
            try
            {
                #region TIMER PAGINACION
                g_timer_Paginar.Interval = 1000;
                g_timer_Paginar.Tick += delegate (object s, EventArgs ee)
                {
                    g_timer_Paginar.Stop();
                    try
                    {
                        g_obj_Controladora.RecargarDatos();
                    }
                    catch (Control_Errores)
                    {
                        Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                        Salir_P_Base();
                    }

                };
                #endregion

                #region INSPECCIONES RELACIONADAS

                //Crear Columnas Listado
                CrearColumnas_Listado_InspeccionesRelacionadas();

                //Poner el tipo de orden si lo hubiera por defecto ###################################################################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_DIRECCION_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Trim().Length > 0)
                {
                    //Descendente
                    if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_DIRECCION_PORDEFECTO.Equals("1"))
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                        ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag = "1";
                    }
                    //Ascendente
                    else
                    {
                        Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                        ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag = "0";
                    }
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_TIPO_PORDEFECTO().Trim().Length > 0)
                    {
                        //Descendente
                        if (g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_TIPO_PORDEFECTO().Equals("1"))
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                            ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag = "1";
                        }
                        //Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                            ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag = "0";

                        }
                    }
                }

                //Seleccionar Orden por Defecto en Combo ###########################################################################################################
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_COLUMNA_PORDEFECTO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_COLUMNA_PORDEFECTO.Trim().Length > 0)
                {
                    ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem = ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Descripcion.Equals(g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_ORDEN_COLUMNA_PORDEFECTO)).FirstOrDefault();
                }
                else
                {
                    if (g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_NOMBRECOLUMNA_PORDEFECTO().Trim().Length > 0)
                    {
                        ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem = ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_NOMBRECOLUMNA_PORDEFECTO())).FirstOrDefault();
                    }
                    else
                    {
                        ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem = ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().FirstOrDefault();
                    }

                }
                #endregion

            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(P_Inspeccion_Load));

                g_bol_ConstructorPantalla_Terminado_Correctamente = false;
            }
        }
        private void P_Inspeccion_Shown(object sender, EventArgs e)
        {
            try
            {
                if (g_bol_ConstructorPantalla_Terminado_Correctamente)
                {
                    // Si el Tipo de Apertura de Pantalla es Añadir(g_int_tipoAperturaPantalla = 0), se desactivan los botones correspondientes
                    // Añadir
                    if (this.P_Base_TipoAperturaPantalla == 0)
                    {
                        P_Base_TituloPantalla = P_Base_TituloPantalla + " - Añadir";

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = true;

                        ActivarBotones(false);

                        //Poner Texto predeterminado y foco
                        if ((P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0) ||
                            (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0))
                        {
                            if (P_Base_Campo_1 != null && P_Base_Campo_1.Trim().Length > 0)
                            {
                                ex_txt_P_Inspeccion_Codigo.Text = P_Base_Campo_1;
                            }
                            if (P_Base_Campo_2 != null && P_Base_Campo_2.Trim().Length > 0)
                            {
                                ex_txt_P_Inspeccion_Codigo.Exferia_TextBox_Foco();
                            }
                        }
                        else
                        {
                            ex_txt_P_Inspeccion_Codigo.Exferia_TextBox_Foco();
                        }

                        g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial = false;
                    }
                    //Modificar
                    else
                    {
                        ActivarBotones(true);

                        //Paginacion
                        if (P_Base_PantallaOrigen != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados != null &&
                           P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.Count > 0)
                        {
                            g_obj_Funciones_Paginador.Listado_ARecorrer(P_Base_PantallaOrigen.P_Base_Objetos_Filtrados.ToList(), 1);

                            // Asignando las paginas totales
                            Exferia_Paginador_Inspeccion.PaginasTotales = g_obj_Funciones_Paginador.Numero_Paginas_Totales;
                        }
                        else
                        {
                            Exferia_Paginador_Inspeccion.Visible = false;
                        }

                        g_obj_Controladora.RecargarDatos();
                    }
                }
            }
            catch (Control_Errores)
            {
                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
            catch (Exception ex)
            {
                //No se muestra mensaje pero se guarda en el log
                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(P_Inspeccion_Shown));

                Mensajes.MostrarMensaje(Mensajes.G_STR_MENSAJES_GENERAL_ERROR_CARGARDATOSPANTALLA());
                Salir_P_Base();
            }
        }
        public void ActivarBotones(bool _bol_Activar)
        {
            if (Exferia_Paginador_Inspeccion.Visible)
            {
                Exferia_Paginador_Inspeccion.Visible = _bol_Activar;
            }

            if (ex_btn_P_Inspeccion_Borrar.Enabled)
            {
                ex_btn_P_Inspeccion_Borrar.Enabled = _bol_Activar;
            }
        }
        #endregion

        #region Botones Grabar, Borrar, BuscarCodigoSiguiente
        private void ex_btn_P_Inspeccion_Grabar_Click(object sender, EventArgs e)
        {
            Grabar();
        }
        private void Grabar()
        {
            if ( //Añadir
                (P_Base_TipoAperturaPantalla == 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Anadir, true)) ||
                //Modificar
                (P_Base_TipoAperturaPantalla != 0 && Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Modificar, true)))
            {
                g_obj_Controladora.GrabarDatos(true);
            }
        }

        private void ex_btn_P_Inspeccion_Borrar_Click(object sender, EventArgs e)
        {
            Borrar();
        }
        private void Borrar()
        {
            if (Datos_Generales.Permisos_Comprobar(g_mdl_PRV_OpcionesDetalle.opcion, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Borrar, true))
            {
                g_obj_Controladora.BorrarDatos(true);
            }
        }

        private void ex_btn_P_Inspeccion_BuscarCodigoSiguiente_Click(object sender, EventArgs e)
        {
            BuscarCodigoSiguiente();
        }
        private void BuscarCodigoSiguiente()
        {
            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = g_obj_Controladora.Buscar_CodigoSiguiente();
            if (mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto == false && mdl_INTERNO_ValorDevuelto_Modelo.Mensaje.Trim().Length > 0)
            {
                Mensajes.MostrarMensaje(mdl_INTERNO_ValorDevuelto_Modelo.Mensaje);
            }
            else
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }
        #endregion

        #region Cliente
        private void ex_usc_F3_P_Inspeccion_Cliente_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if (g_obj_Controladora!=null)
            {
                g_obj_Controladora.Cliente_Modificado();
            }
        }
        #endregion

        #region Instalacion Cabecera
        private void ex_usc_F3_P_Inspeccion_InstalacionCabecera_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null)
            {
                g_obj_Controladora.InstalacionCabecera_Modificado();
            }
           
        }
        #endregion

        #region Instalacion Linea
        private void ex_usc_F3_P_Inspeccion_InstalacionLinea_Exferia_F3_SoloSeleccion_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if (g_obj_Controladora != null)
            {
                g_obj_Controladora.InstalacionLinea_Modificado();
            }
        }
        #endregion

        #region Resultado
        private void ex_usc_F3_P_Inspeccion_Resultado_Exferia_F3_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            try
            {
                if (ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_Id > -1)
                {
                    if (ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_DatosAuxiliares_1!=null &&
                        ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_DatosAuxiliares_1.ToString().Trim().Length>0 &&
                        bool.Parse(ex_usc_F3_P_Inspeccion_Resultado.Exferia_F3_DatosAuxiliares_1.ToString()))
                    {
                        g_obj_Controladora.Resultado_Fechas_BloquearDesbloquear(false);
                    }
                    else
                    {
                        g_obj_Controladora.Resultado_Fechas_BloquearDesbloquear(true);
                    }
                }
                else
                {
                    g_obj_Controladora.Resultado_Fechas_BloquearDesbloquear(true);
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(ex_usc_F3_P_Inspeccion_Resultado_Exferia_F3_Evento_TerminoBusqueda));
            }
        }
        #endregion

        #region Inspeccion Relacionada
        private void ex_usc_F3_P_Inspeccion_InspeccionRelacionada_Exferia_F3_SoloSeleccion_Simple_Evento_TerminoBusqueda(object sender, EventArgs e)
        {
            if (g_obj_Controladora!=null)
            {
                g_obj_Controladora.Rellenar_DataGrid_InspeccionesRelacionadas(g_obj_Controladora.g_mdl_MYT_Inspecciones != null ? g_obj_Controladora.g_mdl_MYT_Inspecciones.id : ex_usc_F3_P_Inspeccion_InspeccionRelacionada.Exferia_F3_SoloSeleccion_Simple_Id,true);
            }
        }

        private void CrearColumnas_Listado_InspeccionesRelacionadas()
        {
            ex_dgv_P_Inspeccion_InspeccionesRelacionadas.AutoGenerateColumns = false;

            g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Inspecciones_Columnas = g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.LISTADO_COLUMNAS().Values.ToList();

            foreach (INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo in g_obj_Controladora.g_lst_INTERNO_ABS_Listado_ColumnasDatos_Modelo_Inspecciones_Columnas)
            {
                DataGridViewTextBoxColumn dgv_Columna = new DataGridViewTextBoxColumn();
                dgv_Columna.DataPropertyName = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.Name = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna;
                dgv_Columna.HeaderText = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar;

                //Poner visible o no .........................................................................
                bool bol_Visible = true;
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto)
                {
                    bol_Visible = false;
                }
                else if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNASAMOSTRAR != null &&
                         g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNASAMOSTRAR.Count > 0)
                {
                    if (!g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNASAMOSTRAR.Contains(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                    {
                        bol_Visible = false;
                    }
                }
                else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Mostrado_PorDefecto == false)
                {
                    bol_Visible = false;
                }
                dgv_Columna.Visible = bol_Visible;


                if (bol_Visible)
                {
                    g_obj_Controladora.g_lst_ColumnasAMostrar_MYT_Inspecciones.Add(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna);
                }
                //.....................................................................................................

                //Tipo de Formateo si fuera Fecha
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                {
                    dgv_Columna.DefaultCellStyle.Format = "d";
                }

                //Poner Ancho Columna ................................................................................
                if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ANCHO != null &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ANCHO.Count > 0 &&
                    g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ANCHO.ContainsKey(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna))
                {
                    dgv_Columna.Width = g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ANCHO[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna];
                }
                else
                {
                    if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho > 0)
                    {
                        dgv_Columna.Width = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Ancho;
                    }
                }
                //................................................................................................................

                dgv_Columna.ReadOnly = true;

                //Poner alineado segun tipo de datos ......................................................................................
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                    mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
                }
                else
                {
                    dgv_Columna.DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleLeft;
                }
                //..............................................................................................................................

                ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns.Add(dgv_Columna);

                //RELLENAR EL ORDEN EN COMBO
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Oculto == false)
                {
                    ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Items.Add(new INTERNO_ComboBox_Modelo(mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna, mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_AMostrar, null));
                }

            }

            //Cambiar el orden de las columnas ........
            if (g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ORDEN != null && g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ORDEN.Count > 0)
            {
                foreach (KeyValuePair<string, int> kvp_Valores in g_mdl_INTERNO_ConfiguracionPantalla_Modelo_INSPECCIONESRELACIONADAS.LISTADO_COLUMNAS_ORDEN)
                {
                    ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[kvp_Valores.Key].DisplayIndex = kvp_Valores.Value;
                }
            }
            //.........................................
        }

        private void ex_dgv_P_Inspeccion_InspeccionesRelacionadas_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            string str_NombreColumna = ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[e.ColumnIndex].Name;

            INTERNO_ABS_Listado_ColumnasDatos_Modelo mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo = g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.LISTADO_COLUMNAS().Values.Where(m => m.DescripcionInterna_CampoAPintar.Equals(str_NombreColumna)).FirstOrDefault();

            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo != null)
            {
                if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.CondicionesColores != null && mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.CondicionesColores.Count > 0)
                {
                    bool bol_Entro = false;
                    Color clr_Letra = Color.Black;
                    Color clr_Fondo = Color.White;
                    string str_ColumnaAPintar = "";

                    //Valor Actual ...........................
                    dynamic dnm_ValorAComparar = null;

                    object obj_Valor = ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna].Value;

                    if (obj_Valor != null)
                    {
                        if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                        { dnm_ValorAComparar = DateTime.ParseExact(obj_Valor.ToString(), "dd/MM/yyyy", CultureInfo.InvariantCulture); }
                        else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL))
                        { dnm_ValorAComparar = decimal.Parse(obj_Valor.ToString().Replace(",", ".")); }
                        else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT))
                        { dnm_ValorAComparar = int.Parse(obj_Valor.ToString()); }
                        else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG))
                        { dnm_ValorAComparar = long.Parse(obj_Valor.ToString()); }
                        else if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT))
                        { dnm_ValorAComparar = long.Parse(obj_Valor.ToString()); }
                        else
                        { dnm_ValorAComparar = ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Descripcion_Interna].Value; }
                    }

                    foreach (INTERNO_ABS_Listado_CondicionesColores_Modelo mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo in mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.CondicionesColores)
                    {
                        clr_Letra = mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.COLOR_LETRA;
                        clr_Fondo = mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.COLOR_FONDO;
                        str_ColumnaAPintar = mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.DescripcionInterna_CampoAPintar;

                        //Igual que
                        if (mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA.Codigo.Equals(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_IGUALA.Codigo))
                        {
                            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.BOOLEAN))
                            {
                                if (dnm_ValorAComparar.Equals("X"))
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }
                            else
                            {
                                if (dnm_ValorAComparar.Equals(mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.VALOR_DECOMPRACION))
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }

                        }
                        //Menor que
                        else if (mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA.Codigo.Equals(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_MENORA.Codigo))
                        {
                            //Solo los tipos de datos numericos y datetime
                            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                            {
                                if (dnm_ValorAComparar < mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.VALOR_DECOMPRACION)
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }
                        }
                        //Menor Igual que
                        else if (mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA.Codigo.Equals(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_MENORIGUALA.Codigo))
                        {
                            //Solo los tipos de datos numericos y datetime
                            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                            {
                                if (dnm_ValorAComparar <= mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.VALOR_DECOMPRACION)
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }
                        }
                        //Mayor que
                        else if (mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA.Codigo.Equals(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_MAYORA.Codigo))
                        {
                            //Solo los tipos de datos numericos y datetime
                            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                            {
                                if (dnm_ValorAComparar > mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.VALOR_DECOMPRACION)
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }
                        }
                        //Mayor Igual que
                        else if (mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA.Codigo.Equals(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_MAYORIGUALA.Codigo))
                        {
                            //Solo los tipos de datos numericos y datetime
                            if (mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.INT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.LONG_TEXT) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DECIMAL) ||
                                mdl_INTERNO_ABS_Listado_ColumnasDatos_Modelo.TipoDato.Equals(G_ENUM_TIPOSDATOS.DATETIME))
                            {
                                if (dnm_ValorAComparar >= mdl_INTERNO_ABS_Listado_CondicionesColores_Modelo.VALOR_DECOMPRACION)
                                {
                                    bol_Entro = true;
                                    break;
                                }
                            }
                        }
                    }

                    if (bol_Entro && str_ColumnaAPintar.Trim().Length > 0)
                    {
                        //Color Fondo
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[str_ColumnaAPintar].Style.BackColor = clr_Fondo;
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[str_ColumnaAPintar].Style.SelectionBackColor = clr_Fondo;

                        //Color Letra
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[str_ColumnaAPintar].Style.ForeColor = clr_Letra;
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows[e.RowIndex].Cells[str_ColumnaAPintar].Style.SelectionForeColor = clr_Letra;

                    }
                }
            }
        }

        #region Botones
        private void ex_btn_P_Inspeccion_InspeccionesRelacionadas_Ver_Click(object sender, EventArgs e)
        {
            Ver_InspeccionesRelacionadas();
        }
        private void ex_dgv_P_Inspeccion_InspeccionesRelacionadas_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            Ver_InspeccionesRelacionadas();
        }
        private void Ver_InspeccionesRelacionadas()
        {
            try
            {
                if ((Datos_Generales.Permisos_Comprobar(Variables.G_STR_OPCION_MYT_INSPECCIONES, g_lst_INTERNO_Permisos_Modelo, (int)G_ENUM_PERMISOS.Ver, true)))
                {
                    //Saber si hay que guardar primero
                    if (g_obj_Controladora.ComprobarCambios())
                    {
                        INTERNO_OpcionesDetalle_Modelo mdl_INTERNO_OpcionesDetalle_Modelo = Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_MYT_INSPECCIONES);

                        //Poner el Listado para el paginado ....................................................
                        List<INTERNO_MYT_Inspecciones_Listado_Modelo> lst_INTERNO_MYT_Inspecciones_Listado_Modelo = g_obj_Controladora.Filtrar_InspeccionesRelacionadas();
                        if (lst_INTERNO_MYT_Inspecciones_Listado_Modelo != null && lst_INTERNO_MYT_Inspecciones_Listado_Modelo.Count > 0)
                        {
                            string str_CampoOrdenar = g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_NOMBRECOLUMNA_PORDEFECTO();
                            if (ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                            {
                                str_CampoOrdenar = ((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador;
                            }

                            //Descendente
                            if (ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag.ToString().Equals("1"))
                            {
                                lst_INTERNO_MYT_Inspecciones_Listado_Modelo = lst_INTERNO_MYT_Inspecciones_Listado_Modelo.OrderByDescending(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                            }
                            //Ascendente
                            else
                            {
                                lst_INTERNO_MYT_Inspecciones_Listado_Modelo = lst_INTERNO_MYT_Inspecciones_Listado_Modelo.OrderBy(m => m.GetType().GetProperty(str_CampoOrdenar).GetValue(m, null)).ToList();
                            }

                            P_Base_Objetos_Filtrados = lst_INTERNO_MYT_Inspecciones_Listado_Modelo.Select(m => new INTERNO_Listado_CamposClave_Modelo { ID = m.id }).ToList();
                        }
                        else
                        {
                            P_Base_Objetos_Filtrados = null;
                        }
                        //......................................................................................


                        //Cargamos el ensamblado
                        Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MYTHOS + ".dll");
                        //Obtenemos el tipo de la clase
                        Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MYTHOS + "." + Variables.G_STR_LIBRERIA_OPCIONES);
                        //creamos la instancia
                        var obj_Clase = Activator.CreateInstance(m_type);
                        //Cargamos el metodo solicitado
                        MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_OPCIONES_PROCEDIMIENTO_MOSTRAR_EN_MANTENIMIENTO, BindingFlags.Instance | BindingFlags.NonPublic);

                        object[] arr_Parametros = { Variables.G_STR_OPCION_MYT_INSPECCIONES,
                                                    this,
                                                    null,
                                                    this.P_Base_ValoresGenerales,
                                                    this.P_Base_FechaTrabajo,
                                                    mdl_INTERNO_OpcionesDetalle_Modelo,
                                                    long.Parse(ex_dgv_P_Inspeccion_InspeccionesRelacionadas.SelectedRows[0].Cells[nameof(INTERNO_MYT_Inspecciones_Listado_Modelo.id)].Value.ToString()),
                                                    "",
                                                    "",
                                                    null,
                                                    null};
                        //Pasamos los parametros al metodo y lo ejecutamos
                        obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
                    }
                }
            }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(Ver_InspeccionesRelacionadas));
            }
        }
        #endregion

        #region Ordenar
        private void ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado_Click(object sender, EventArgs e)
        {
            //Esta Descedente
            if (ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag.ToString().Equals("1"))
            {
                Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
            }
            //Esta Ascendente
            else
            {
                Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
            }

            Ordenar_DataGridView_InspeccionesRelacionadas();
        }
        private void ex_dgv_P_Inspeccion_InspeccionesRelacionadas_ColumnHeaderMouseClick(object sender, DataGridViewCellMouseEventArgs e)
        {
            try
            {
                //Mostrar u Ocultar las columnas
                if (e.Button == MouseButtons.Left)
                {
                    string str_CambioOrdenAnterior = "";
                    if (ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem != null)
                    {
                        str_CambioOrdenAnterior = ((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador;
                    }

                    //Seleccionar la columna en el Combo de orden
                    ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem = ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Items.Cast<INTERNO_ComboBox_Modelo>().Where(m => m.Identificador.Equals(ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[e.ColumnIndex].Name)).FirstOrDefault();

                    if (str_CambioOrdenAnterior.Equals(((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador))
                    {
                        //Si estaba Ascendente lo pongo descendente
                        if (ex_dgv_P_Inspeccion_InspeccionesRelacionadas.SortOrder == SortOrder.Ascending)
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(1, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                        }
                        //Si estaba descendente lo pongo Ascendente
                        else
                        {
                            Funciones.Cambiar_Imagen_Boton_Orden(0, ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado);
                        }
                    }

                    Ordenar_DataGridView_InspeccionesRelacionadas();
                }
            }
            catch
            { }
        }
        private void ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado_SelectedIndexChanged(object sender, EventArgs e)
        {
            //Saber el Tipo de Ordenacion .................................
            ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
            if (ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag.ToString().Equals("1"))
            {
                obj_ListSortDirection = ListSortDirection.Descending;
            }
            //..............................................................

            //Cambiar el tipo Orden en Listado
            ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Sort(ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);

            Ordenar_DataGridView_InspeccionesRelacionadas();
        }

        public void Ordenar_DataGridView_InspeccionesRelacionadas()
        {
            try
            {
                if (ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Rows.Count > 0)
                {
                    //Saber el Tipo de Ordenacion .................................
                    ListSortDirection obj_ListSortDirection = ListSortDirection.Ascending;
                    if (ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag.ToString().Equals("1"))
                    {
                        obj_ListSortDirection = ListSortDirection.Descending;
                    }
                    //..............................................................

                    if (ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem != null && ((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador.Trim().Length > 0)
                    {
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Sort(ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Identificador], obj_ListSortDirection);
                    }
                    else
                    {
                        ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Sort(ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns[g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.ORDENACION_NOMBRECOLUMNA_PORDEFECTO()], obj_ListSortDirection);
                    }
                }
            }
            catch (Exception)
            { }
        }

        #endregion

        #region Filtros
        private void ex_btn_P_Inspeccion_InspeccionesRelacionadas_VerFiltrosCampos_Click(object sender, EventArgs e)
        {
            MostrarOcultar_Columnas_Y_Fitros_InspeccionesRelacionadas(ex_btn_P_Inspeccion_InspeccionesRelacionadas_VerFiltrosCampos.Location.X, 0);
        }
        private void MostrarOcultar_Columnas_Y_Fitros_InspeccionesRelacionadas(int _int_PosicionX, int _int_PosicionY)
        {
            PE_Listados_Filtros frm_PE_Listados_Filtros = new PE_Listados_Filtros(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion, ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns, g_obj_Controladora.g_dct_ListadoFiltros_MYT_Inspecciones);

            frm_PE_Listados_Filtros.ShowDialog();

            if (frm_PE_Listados_Filtros.g_bol_BotonAceptar)
            {
                //Mostrar/Ocultar las Columnas que no esten en el Listado
                g_obj_Controladora.g_lst_ColumnasAMostrar_MYT_Inspecciones = frm_PE_Listados_Filtros.g_lst_ColumnasAMostrar;

                foreach (DataGridViewColumn dgvc_ColumnasActuales in ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns)
                {
                    //Mostrar
                    if (g_obj_Controladora.g_lst_ColumnasAMostrar_MYT_Inspecciones.Contains(dgvc_ColumnasActuales.Name))
                    {
                        dgvc_ColumnasActuales.Visible = true;
                    }
                    //Ocultar
                    else
                    {
                        dgvc_ColumnasActuales.Visible = false;
                    }
                }

                //Rellenar los nuevos filtros
                g_obj_Controladora.g_dct_ListadoFiltros_MYT_Inspecciones = frm_PE_Listados_Filtros.g_dct_ListadoFiltros.ToDictionary(entry => entry.Key, entry => entry.Value);

                //Recargar el Listado
                g_obj_Controladora.Rellenar_DataGrid_InspeccionesRelacionadas(g_obj_Controladora.g_mdl_MYT_Inspecciones!=null ? g_obj_Controladora.g_mdl_MYT_Inspecciones.id : ex_usc_F3_P_Inspeccion_InspeccionRelacionada.Exferia_F3_SoloSeleccion_Simple_Id,false);
            }
        }
        #endregion
        #endregion

        #region Eventos del Paginador
        protected void ctu_Paginacion_Primera_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempospasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Primera())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Inspeccion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        private void ctu_Paginacion_Anterior_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Anterior())
                {
                    //Asignando al control la pagina actual.
                    Exferia_Paginador_Inspeccion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Refrescamos el listado a mostrar en el form
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Siguiente_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {

                if (g_obj_Funciones_Paginador.Siguiente())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Inspeccion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void ctu_Paginacion_Ultima_Click(object sender, EventArgs e)
        {
            if (g_obj_Controladora.ComprobarCambios()) // Si no han habido contratiempos pasamos a la pagina indicada
            {
                if (g_obj_Funciones_Paginador.Ultima())
                {
                    // Asignando al control la pagina actual.
                    Exferia_Paginador_Inspeccion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    // Refrescamos el listado a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_timer_Paginar.Start();
                }
            }
        }

        protected void txt_PaginaActual_KeyPress(object sender, KeyPressEventArgs e)
        {
            // si pulsamos Enter.
            if (e.KeyChar.Equals('\r'))
            {
                if (g_obj_Controladora.ComprobarCambios()) //Si no han habido contratiempos pasamos a la pagina indicada
                {
                    //Asignamos a la paginacion el valor del textbox
                    g_obj_Funciones_Paginador.SetPaginaActual(Exferia_Paginador_Inspeccion.txt_ValorPaginaActual - 1);

                    //Asignamos al control la pagina actual
                    Exferia_Paginador_Inspeccion.PaginaActual = g_obj_Funciones_Paginador.GetPaginaActual();

                    //Regrescamos el listad a mostrar en el form.
                    P_Base_id = g_obj_Funciones_Paginador.Objeto_Devuelto.FirstOrDefault().ID;

                    g_timer_Paginar.Stop();
                    g_obj_Controladora.RecargarDatos();
                }
            }
        }
        #endregion

        #region Teclas de acceso rapido
        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // Salir sin Seleccionar
            if (keyData == Keys.F10)
            {
                Salir_P_Base();
                return true;
            }
            // Grabar
            else if (keyData == Keys.F2)
            {
                Grabar();
                return true;
            }
            // Borrar
            else if (keyData == Keys.F5)
            {
                Borrar();
                return true;
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }
        #endregion

        #region Controlar si se modifica algo
        private void Controlar_Modificaciones_TextBox_TextChanged(object sender, EventArgs e)
        {
            Controlar_Modificaciones();
        }

        private void Controlar_Modificaciones()
        {
            if (Enabled && g_obj_Controladora != null && g_obj_Controladora.g_bol_Termino_CargaDatos_Inicial)
            {
                P_Base_SeModificoDatosPantalla = true;
            }
        }




        #endregion

        private void P_Inspeccion_FormClosed(object sender, FormClosedEventArgs e)
        {
            try
            {
                //GUARDAR EL FICHERO XML DE CONFIGURACION DE LA PANTALLA

                //Listado de Agrupaciones Registros Seleccionados.......................................................
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo_REGISTROSSELECCIONADOS = new INTERNO_ConfiguracionPantalla_Modelo();

                Dictionary<string, int> dct_ColumnasOrden_REGISTROSSELECCIONADOS = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_REGISTROSSELECCIONADOS = new Dictionary<string, int>();

                //Listado de Contactos....................................................................................
                INTERNO_ConfiguracionPantalla_Modelo mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos = new INTERNO_ConfiguracionPantalla_Modelo();
                Dictionary<string, int> dct_ColumnasOrden_Contactos = new Dictionary<string, int>();
                Dictionary<string, int> dct_ColumnasAncho_Contactos = new Dictionary<string, int>();
                foreach (DataGridViewColumn dgv_Columnas in ex_dgv_P_Inspeccion_InspeccionesRelacionadas.Columns)
                {
                    //Campos a Mostrar
                    if (dgv_Columnas.Visible)
                    {
                        //Columnas Orden
                        dct_ColumnasOrden_Contactos.Add(dgv_Columnas.Name, dgv_Columnas.DisplayIndex);

                        //Columnas Ancho
                        dct_ColumnasAncho_Contactos.Add(dgv_Columnas.Name, dgv_Columnas.Width);
                    }
                }
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos.LISTADO_COLUMNASAMOSTRAR = g_obj_Controladora.g_lst_ColumnasAMostrar_MYT_Inspecciones;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos.LISTADO_COLUMNAS_ORDEN = dct_ColumnasOrden_Contactos;
                mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos.LISTADO_COLUMNAS_ANCHO = dct_ColumnasAncho_Contactos;

                //Orden
                if (ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem != null)
                {
                    mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos.LISTADO_ORDEN_COLUMNA_PORDEFECTO = ((INTERNO_ComboBox_Modelo)ex_cbo_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.SelectedItem).Descripcion;
                }

                mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos.LISTADO_ORDEN_DIRECCION_PORDEFECTO = ex_btn_P_Inspeccion_InspeccionesRelacionadas_OrdenListado.Tag.ToString();

                //Actualizar las Variables Generales
                if (Variables.G_DCT_CONFIGURACIONPANTALLA != null && Variables.G_DCT_CONFIGURACIONPANTALLA.Count > 0)
                {
                    //Ver si ya existia
                    if (Variables.G_DCT_CONFIGURACIONPANTALLA.ContainsKey(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION()))
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA[g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION()] = mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos;
                    }
                    else
                    {
                        Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos);
                    }
                }
                else
                {
                    Variables.G_DCT_CONFIGURACIONPANTALLA = new Dictionary<string, INTERNO_ConfiguracionPantalla_Modelo>();
                    Variables.G_DCT_CONFIGURACIONPANTALLA.Add(g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos);
                }
                //Actualizar el fichero XML
                Funciones_FicherosXML.ModificarXML_ConfiguracionPantallas(Variables.G_STR_CONFIGURACIONPANTALLA_TIPOPANTALLA_LISTADOS, g_obj_Controladora.g_obj_ABS_Listado_MYT_Inspecciones_P_Inspeccion.NOMBRELISTADO_ALMACENARCONFIGURACION(), mdl_INTERNO_ConfiguracionPantalla_Modelo_Contactos);
            }
            catch (Control_Errores)
            { }
            catch (Exception ex)
            {
                Control_Errores.Errores_Log("", ex, nameof(P_Inspeccion) + "/" + nameof(P_Inspeccion_FormClosed));
            }
        }

    }
}
